const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

mongoose.Promise = global.Promise;
mongoose.level = "F";

const tools = require('../tools/general');

const { ObjectID } = require('mongodb');

// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const GoodSchema = new Schema({
  _id: {
    type: Number,
  },
  descr: {
    type: String,
  },
  idSectorGood: [{
    type: Number
  }],
  icon: {
    type: String,
  },
  img: {
    type: String,
  },
});

GoodSchema.statics.findAllIdApp = async function (idapp) {
  const Good = this;

  const query = [
    { $sort: { descr: 1 } }
  ];

  const res = await Good
    .aggregate(query)
    .then((arrrec) => {
      return arrrec
    })

  return res;

};

GoodSchema.pre('save', async function (next) {
  if (this.isNew) {
    const myrec = await Good.findOne().limit(1).sort({_id:-1});
    if (!!myrec) {
      if (myrec._doc._id === 0)
        this._id = 1;
      else
        this._id = myrec._doc._id + 1;

    } else {
      this._id = 1;
    }
  }

  next();
});



GoodSchema.statics.getFieldsForSearch = function () {
  return [{ field: 'label', type: tools.FieldType.string },
    { field: 'descr', type: tools.FieldType.string }]
};

GoodSchema.statics.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, 0, params);
};


const Good = mongoose.model('Good', GoodSchema);

module.exports = { Good };
